## nnn 1.3

=== Makefile ===
VERSION = 1.3

PREFIX ?= /usr/local
MANPREFIX = $(PREFIX)/share/man

CFLAGS += -O2 -Wall -Wextra -Wno-unused-parameter
LDLIBS = -lreadline

ifeq ($(shell pkg-config ncursesw && echo 1),1)
	CFLAGS += $(shell pkg-config --cflags ncursesw)
	LDLIBS += $(shell pkg-config --libs   ncursesw)
else
	LDLIBS += -lncurses
endif

DISTFILES = nlay nnn.c config.h nnn.1 Makefile README.md LICENSE
SRC = nnn.c
BIN = nnn
PLAYER = nlay

all: $(BIN) $(PLAYER)

$(SRC): config.h

$(BIN): $(SRC)
	$(CC) $(CFLAGS) -o $@ $^ $(LDFLAGS) $(LDLIBS)
	strip $@

debug: $(SRC)
	$(CC) -DDEBUGMODE -g $(CFLAGS) -o nnndbg $^ $(LDFLAGS) $(LDLIBS)

install: all
	mkdir -p $(DESTDIR)$(PREFIX)/bin
	cp -f $(BIN) $(DESTDIR)$(PREFIX)/bin
	cp -f $(PLAYER) $(DESTDIR)$(PREFIX)/bin
	mkdir -p $(DESTDIR)$(MANPREFIX)/man1
	cp -f $(BIN).1 $(DESTDIR)$(MANPREFIX)/man1

uninstall:
	rm -f $(DESTDIR)$(PREFIX)/bin/$(BIN)
	rm -f $(DESTDIR)$(PREFIX)/bin/$(PLAYER)
	rm -f $(DESTDIR)$(MANPREFIX)/man1/$(BIN).1

dist:
	mkdir -p nnn-$(VERSION)
	cp $(DISTFILES) nnn-$(VERSION)
	tar -cf nnn-$(VERSION).tar nnn-$(VERSION)
	gzip nnn-$(VERSION).tar
	rm -rf nnn-$(VERSION)

clean:
	rm -f $(BIN) nnn-$(VERSION).tar.gz

=== debian/changelog ===
nnn (1.3-2) unstable; urgency=medium

  * Update manpage

 -- SZ Lin (林上智) <szlin@debian.org>  Wed, 26 Jul 2017 17:39:29 +0800

nnn (1.3-1) unstable; urgency=medium

  * Import new upstream version

 -- SZ Lin (林上智) <szlin@debian.org>  Wed, 26 Jul 2017 17:26:38 +0800

nnn (1.2-1) unstable; urgency=medium

  * New upstream version
  * Fix FTBFS on non-Linux issue (Closes: #862421)
  * Bump Standards-Version to 4.0.0

 -- SZ Lin (林上智) <szlin@debian.org>  Thu, 29 Jun 2017 13:57:39 +0800

nnn (1.1-1) unstable; urgency=medium

  * New upstream version
  * Set build-depends to libncursesw5-dev only (Closes: #860518)
  * Move package from experimental to SID archive

 -- SZ Lin (林上智) <szlin@debian.org>  Tue, 18 Apr 2017 14:46:23 +0800

nnn (1.0-1~exp2) experimental; urgency=medium

  * Remove -march=native and change -O3 to -O2 in cflags (Closes: #860455)

 -- SZ Lin (林上智) <szlin@debian.org>  Mon, 17 Apr 2017 19:38:17 +0800

nnn (1.0-1~exp1) experimental; urgency=low

  * Initial release (Closes: #860249)

 -- SZ Lin (林上智) <szlin@debian.org>  Sat, 15 Apr 2017 11:19:09 +0800

=== debian/control ===
Source: nnn
Section: misc
Priority: optional
Maintainer: SZ Lin (林上智) <szlin@debian.org>
Build-Depends: debhelper (>= 10),
               dh-systemd,
               libncursesw5-dev,
               libreadline-dev,
               pkg-config
Standards-Version: 4.0.0
Homepage: https://github.com/jarun/nnn
Vcs-Git: https://anonscm.debian.org/git/collab-maint/nnn.git
Vcs-Browser: https://anonscm.debian.org/git/collab-maint/nnn.git

Package: nnn
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: Free, fast, friendly file browser
 nnn is a fork of noice, a blazing-fast lightweight terminal file browser
 with easy keyboard shortcuts for navigation, opening files and running tasks.
 nnn toppings
 .
  - Show details of the currently selected file (stat, file)
  - Disk usage analyzer mode (within the same fs, doesn't follow symlinks)
  - Directories first (even with sorting)
  - Sort numeric names in numeric order
  - Case-insensitive alphabetic content listing instead of upper case first
  - Key - to jump to last visited directory
  - Roll over at the first and last entries of a directory
  - Removed navigation restriction with relative paths
  - Sort entries by file size (largest to smallest)
  - Shortcut to invoke file name copier

=== debian/rules ===
#!/usr/bin/make -f

export DEB_BUILD_MAINT_OPTIONS = hardening=+all

%:
	dh $@ --parallel --with systemd

override_dh_auto_install:

## nnn 1.5

=== Makefile ===
--- 
+++ 
@@ -1,9 +1,9 @@
-VERSION = 1.3
+VERSION = 1.5
 
 PREFIX ?= /usr/local
 MANPREFIX = $(PREFIX)/share/man
 
-CFLAGS += -O2 -Wall -Wextra -Wno-unused-parameter
+CFLAGS += -O3 -Wall -Wextra -Wno-unused-parameter
 LDLIBS = -lreadline
 
 ifeq ($(shell pkg-config ncursesw && echo 1),1)
@@ -13,14 +13,14 @@
 	LDLIBS += -lncurses
 endif
 
-DISTFILES = nlay nnn.c config.h nnn.1 Makefile README.md LICENSE
+DISTFILES = nlay nnn.c nnn.h nnn.1 Makefile README.md LICENSE
 SRC = nnn.c
 BIN = nnn
 PLAYER = nlay
 
 all: $(BIN) $(PLAYER)
 
-$(SRC): config.h
+$(SRC): nnn.h
 
 $(BIN): $(SRC)
 	$(CC) $(CFLAGS) -o $@ $^ $(LDFLAGS) $(LDLIBS)

=== debian/changelog ===
nnn (1.5-1) unstable; urgency=medium

  * Import new upstream version
  * Bump Standards-Version to 4.1.1
  * Replace "http" with "https" in d/copyright
  * Remove dh-systemd dep. in d/control

 -- SZ Lin (林上智) <szlin@debian.org>  Thu, 05 Oct 2017 13:34:59 +0800

nnn (1.4-1) unstable; urgency=medium

  * Import new upstream version
  * Bump Standards-Version to 4.1.0

 -- SZ Lin (林上智) <szlin@debian.org>  Mon, 04 Sep 2017 14:21:17 +0800

=== debian/control ===
--- 
+++ 
@@ -3,11 +3,10 @@
 Priority: optional
 Maintainer: SZ Lin (林上智) <szlin@debian.org>
 Build-Depends: debhelper (>= 10),
-               dh-systemd,
                libncursesw5-dev,
                libreadline-dev,
                pkg-config
-Standards-Version: 4.0.0
+Standards-Version: 4.1.1
 Homepage: https://github.com/jarun/nnn
 Vcs-Git: https://anonscm.debian.org/git/collab-maint/nnn.git
 Vcs-Browser: https://anonscm.debian.org/git/collab-maint/nnn.git

## nnn 1.7

=== Makefile ===
VERSION = 1.7

PREFIX ?= /usr/local
MANPREFIX ?= $(PREFIX)/share/man
STRIP ?= strip
PKG_CONFIG ?= pkg-config

CFLAGS ?= -O3
CFLAGS += -Wall -Wextra -Wno-unused-parameter
LDLIBS = -lreadline

ifeq ($(shell $(PKG_CONFIG) ncursesw && echo 1),1)
	CFLAGS += $(shell $(PKG_CONFIG) --cflags ncursesw)
	LDLIBS += $(shell $(PKG_CONFIG) --libs   ncursesw)
else
	LDLIBS += -lncurses
endif

DISTFILES = nlay nnn.c nnn.h nnn.1 Makefile README.md LICENSE
SRC = nnn.c
BIN = nnn
PLAYER = nlay

all: $(BIN) $(PLAYER)

$(SRC): nnn.h

$(BIN): $(SRC)
	$(CC) $(CFLAGS) $(LDFLAGS) -o $@ $^ $(LDLIBS)

debug: $(SRC)
	$(CC) -DDEBUGMODE -g $(CFLAGS) $(LDFLAGS) -o $(BIN) $^ $(LDLIBS)

install: all
	install -m 0755 -d $(DESTDIR)$(PREFIX)/bin
	install -m 0755 -t $(DESTDIR)$(PREFIX)/bin $(BIN) $(PLAYER)
	install -m 0755 -d $(DESTDIR)$(MANPREFIX)/man1
	install -m 0644 -t $(DESTDIR)$(MANPREFIX)/man1 $(BIN).1

uninstall:
	$(RM) $(DESTDIR)$(PREFIX)/bin/$(BIN)
	$(RM) $(DESTDIR)$(PREFIX)/bin/$(PLAYER)
	$(RM) $(DESTDIR)$(MANPREFIX)/man1/$(BIN).1

strip: $(BIN)
	$(STRIP) $^

dist:
	mkdir -p nnn-$(VERSION)
	$(CP) $(DISTFILES) nnn-$(VERSION)
	tar -cf nnn-$(VERSION).tar nnn-$(VERSION)
	gzip nnn-$(VERSION).tar
	$(RM) -r nnn-$(VERSION)

clean:
	$(RM) -f $(BIN) nnn-$(VERSION).tar.gz

.PHONY: all debug install uninstall strip dist clean

=== debian/changelog ===
nnn (1.7-1) unstable; urgency=medium

  * Import new upstream version
  * d/control: Move VCS to salsa
  *            Bump standards version to 4.1.3

 -- SZ Lin (林上智) <szlin@debian.org>  Wed, 28 Feb 2018 22:23:50 +0800

nnn (1.6-1) unstable; urgency=medium

  * Import new upstream version
  * d/control: Bump Standards-Version to 4.1.2
  * d/compat: Bump compat to 11
  * d/rules: Remove unnecessary parameters

 -- SZ Lin (林上智) <szlin@debian.org>  Tue, 26 Dec 2017 09:47:30 +0800

=== debian/control ===
--- 
+++ 
@@ -2,14 +2,14 @@
 Section: misc
 Priority: optional
 Maintainer: SZ Lin (林上智) <szlin@debian.org>
-Build-Depends: debhelper (>= 10),
+Build-Depends: debhelper (>= 11),
                libncursesw5-dev,
                libreadline-dev,
                pkg-config
-Standards-Version: 4.1.1
+Standards-Version: 4.1.3
 Homepage: https://github.com/jarun/nnn
-Vcs-Git: https://anonscm.debian.org/git/collab-maint/nnn.git
-Vcs-Browser: https://anonscm.debian.org/git/collab-maint/nnn.git
+Vcs-Git: https://salsa.debian.org/debian/nnn.git
+Vcs-Browser: https://salsa.debian.org/debian/nnn
 
 Package: nnn
 Architecture: any

=== debian/watch ===
version=4
opts="filenamemangle=s%(?:.*?)?v?(\d[\d.]*)\.tar\.gz%<project>-$1.tar.gz%" \
   https://github.com/jarun/nnn/releases \
   (?:.*?/)?v?(\d[\d.]*)\.tar\.gz debian uupdate

## nnn 1.9

=== Makefile ===
VERSION = 1.9

PREFIX ?= /usr/local
MANPREFIX ?= $(PREFIX)/share/man
STRIP ?= strip
PKG_CONFIG ?= pkg-config
INSTALL ?= install

CFLAGS ?= -O3
CFLAGS += -Wall -Wextra -Wno-unused-parameter
LDLIBS = -lreadline

ifeq ($(shell $(PKG_CONFIG) ncursesw && echo 1),1)
	CFLAGS += $(shell $(PKG_CONFIG) --cflags ncursesw)
	LDLIBS += $(shell $(PKG_CONFIG) --libs   ncursesw)
else
	LDLIBS += -lncurses
endif

DISTFILES = nlay nlay.1 nnn.c nnn.h nnn.1 Makefile README.md LICENSE
SRC = nnn.c
BIN = nnn
PLAYER = nlay

all: $(BIN) $(PLAYER)

$(SRC): nnn.h

$(BIN): $(SRC)
	$(CC) $(CFLAGS) $(LDFLAGS) -o $@ $^ $(LDLIBS)

debug: $(SRC)
	$(CC) -DDEBUGMODE -g $(CFLAGS) $(LDFLAGS) -o $(BIN) $^ $(LDLIBS)

install: all
	$(INSTALL) -m 0755 -d $(DESTDIR)$(PREFIX)/bin
	$(INSTALL) -m 0755 $(BIN) $(PLAYER) $(DESTDIR)$(PREFIX)/bin
	$(INSTALL) -m 0755 -d $(DESTDIR)$(MANPREFIX)/man1
	$(INSTALL) -m 0644 $(BIN).1 $(DESTDIR)$(MANPREFIX)/man1
	$(INSTALL) -m 0644 $(PLAYER).1 $(DESTDIR)$(MANPREFIX)/man1

uninstall:
	$(RM) $(DESTDIR)$(PREFIX)/bin/$(BIN)
	$(RM) $(DESTDIR)$(PREFIX)/bin/$(PLAYER)
	$(RM) $(DESTDIR)$(MANPREFIX)/man1/$(BIN).1
	$(RM) $(DESTDIR)$(MANPREFIX)/man1/$(PLAYER).1

strip: $(BIN)
	$(STRIP) $^

dist:
	mkdir -p nnn-$(VERSION)
	$(CP) $(DISTFILES) nnn-$(VERSION)
	tar -cf nnn-$(VERSION).tar nnn-$(VERSION)
	gzip nnn-$(VERSION).tar
	$(RM) -r nnn-$(VERSION)

clean:
	$(RM) -f $(BIN) nnn-$(VERSION).tar.gz

.PHONY: $(BIN) $(SRC) all debug install uninstall strip dist clean

=== debian/changelog ===
nnn (1.9-1) unstable; urgency=medium

  * Import new upstream version
  * d/control: Bump Standards-Version to 4.2.0

 -- SZ Lin (林上智) <szlin@debian.org>  Fri, 10 Aug 2018 14:29:00 +0800

nnn (1.8-1) unstable; urgency=medium

  * Import new upstream version
  * Convert from git-dpm to patches unapplied format
  * d/control: Bump Standards-Version to 4.1.4

 -- SZ Lin (林上智) <szlin@debian.org>  Wed, 02 May 2018 10:29:53 +0800

=== debian/control ===
--- 
+++ 
@@ -6,7 +6,7 @@
                libncursesw5-dev,
                libreadline-dev,
                pkg-config
-Standards-Version: 4.1.3
+Standards-Version: 4.2.0
 Homepage: https://github.com/jarun/nnn
 Vcs-Git: https://salsa.debian.org/debian/nnn.git
 Vcs-Browser: https://salsa.debian.org/debian/nnn

## nnn 2.0

=== Makefile ===
--- 
+++ 
@@ -1,4 +1,4 @@
-VERSION = 1.9
+VERSION = 2.0
 
 PREFIX ?= /usr/local
 MANPREFIX ?= $(PREFIX)/share/man
@@ -8,7 +8,6 @@
 
 CFLAGS ?= -O3
 CFLAGS += -Wall -Wextra -Wno-unused-parameter
-LDLIBS = -lreadline
 
 ifeq ($(shell $(PKG_CONFIG) ncursesw && echo 1),1)
 	CFLAGS += $(shell $(PKG_CONFIG) --cflags ncursesw)

=== debian/changelog ===
nnn (2.0-2) unstable; urgency=medium

  * d/control:
    - Remove unnecessary depends: libncursesw5 (Closes: #911741)
    - Update Build-Depends to libncurses-dev (Thanks to Sven and Dmitry)
  * d/nnn.manpages:
    - Add missing manpage of nlay (Closes:#911755)

 -- SZ Lin (林上智) <szlin@debian.org>  Wed, 24 Oct 2018 22:03:42 +0800

nnn (2.0-1) unstable; urgency=medium

  * Import new upstream version
  * Add upstream metadata
  * d/control:
    - Bump Standards-Version to 4.2.1
    - Add missing depends: libncursesw5
    - Remove Build-Depends: libreadline-dev
    - Tidy package description
  * d/install:
    - Add auto-completion shell in bash

 -- SZ Lin (林上智) <szlin@debian.org>  Mon, 22 Oct 2018 11:43:30 +0800

=== debian/control ===
--- 
+++ 
@@ -3,10 +3,9 @@
 Priority: optional
 Maintainer: SZ Lin (林上智) <szlin@debian.org>
 Build-Depends: debhelper (>= 11),
-               libncursesw5-dev,
-               libreadline-dev,
+               libncurses-dev,
                pkg-config
-Standards-Version: 4.2.0
+Standards-Version: 4.2.1
 Homepage: https://github.com/jarun/nnn
 Vcs-Git: https://salsa.debian.org/debian/nnn.git
 Vcs-Browser: https://salsa.debian.org/debian/nnn
@@ -14,8 +13,8 @@
 Package: nnn
 Architecture: any
 Depends: ${shlibs:Depends}, ${misc:Depends}
-Description: Free, fast, friendly file browser
- nnn is a fork of noice, a blazing-fast lightweight terminal file browser
+Description: Free, fast, friendly file manager
+ nnn is a fork of noice, a blazing-fast lightweight terminal file manager
  with easy keyboard shortcuts for navigation, opening files and running tasks.
  nnn toppings
  .

## nnn 2.1

=== Makefile ===
VERSION = 2.1

PREFIX ?= /usr/local
MANPREFIX ?= $(PREFIX)/share/man
STRIP ?= strip
PKG_CONFIG ?= pkg-config
INSTALL ?= install

CFLAGS ?= -O3
CFLAGS += -Wall -Wextra -Wno-unused-parameter

ifeq ($(shell $(PKG_CONFIG) ncursesw && echo 1),1)
	CFLAGS += $(shell $(PKG_CONFIG) --cflags ncursesw)
	LDLIBS += $(shell $(PKG_CONFIG) --libs   ncursesw)
else
	LDLIBS += -lncurses
endif

DISTFILES = src nnn.1 Makefile README.md LICENSE
SRC = src/nnn.c
BIN = nnn

all: $(BIN)

$(SRC): src/nnn.h

$(BIN): $(SRC)
	$(CC) $(CPPFLAGS) $(CFLAGS) $(LDFLAGS) -o $@ $^ $(LDLIBS)

debug: $(SRC)
	$(CC) -DDEBUGMODE -g $(CPPFLAGS) $(CFLAGS) $(LDFLAGS) -o $(BIN) $^ $(LDLIBS)

install: all
	$(INSTALL) -m 0755 -d $(DESTDIR)$(PREFIX)/bin
	$(INSTALL) -m 0755 $(BIN) $(DESTDIR)$(PREFIX)/bin
	$(INSTALL) -m 0755 -d $(DESTDIR)$(MANPREFIX)/man1
	$(INSTALL) -m 0644 $(BIN).1 $(DESTDIR)$(MANPREFIX)/man1

uninstall:
	$(RM) $(DESTDIR)$(PREFIX)/bin/$(BIN)
	$(RM) $(DESTDIR)$(MANPREFIX)/man1/$(BIN).1

strip: $(BIN)
	$(STRIP) $^

dist:
	mkdir -p nnn-$(VERSION)
	$(CP) -r $(DISTFILES) nnn-$(VERSION)
	tar -cf nnn-$(VERSION).tar nnn-$(VERSION)
	gzip nnn-$(VERSION).tar
	$(RM) -r nnn-$(VERSION)

clean:
	$(RM) -f $(BIN) nnn-$(VERSION).tar.gz

skip: ;

.PHONY: $(BIN) $(SRC) all debug install uninstall strip dist clean

=== debian/changelog ===
nnn (2.1-1) unstable; urgency=medium

  * Import new upstream version
  * d/install:
    - Remove nlay - which was dropped by new upstream release
  * d/nnn.manpages:
    - Remove nlay.1 - which was dropped by new upstream release

 -- SZ Lin (林上智) <szlin@debian.org>  Mon, 26 Nov 2018 12:03:55 +0800

## nnn 2.2

=== Makefile ===
--- 
+++ 
@@ -1,4 +1,4 @@
-VERSION = 2.1
+VERSION = 2.2
 
 PREFIX ?= /usr/local
 MANPREFIX ?= $(PREFIX)/share/man
@@ -6,15 +6,23 @@
 PKG_CONFIG ?= pkg-config
 INSTALL ?= install
 
-CFLAGS ?= -O3
-CFLAGS += -Wall -Wextra -Wno-unused-parameter
+CFLAGS_OPTIMIZATION ?= -O3
 
 ifeq ($(shell $(PKG_CONFIG) ncursesw && echo 1),1)
-	CFLAGS += $(shell $(PKG_CONFIG) --cflags ncursesw)
-	LDLIBS += $(shell $(PKG_CONFIG) --libs   ncursesw)
+	CFLAGS_CURSES ?= $(shell $(PKG_CONFIG) --cflags ncursesw)
+	LDLIBS_CURSES ?= $(shell $(PKG_CONFIG) --libs   ncursesw)
+else ifeq ($(shell $(PKG_CONFIG) ncurses && echo 1),1)
+	CFLAGS_CURSES ?= $(shell $(PKG_CONFIG) --cflags ncurses)
+	LDLIBS_CURSES ?= $(shell $(PKG_CONFIG) --libs   ncurses)
 else
-	LDLIBS += -lncurses
+	LDLIBS_CURSES ?= -lncurses
 endif
+
+CFLAGS += -Wall -Wextra -Wno-unused-parameter
+CFLAGS += $(CFLAGS_OPTIMIZATION)
+CFLAGS += $(CFLAGS_CURSES)
+
+LDLIBS += $(LDLIBS_CURSES)
 
 DISTFILES = src nnn.1 Makefile README.md LICENSE
 SRC = src/nnn.c

=== debian/changelog ===
nnn (2.2-2) unstable; urgency=medium

  * Add suggests fields with optional dependencies (Closes: #921480)

 -- SZ Lin (林上智) <szlin@debian.org>  Mon, 11 Feb 2019 13:19:30 +0800

nnn (2.2-1) unstable; urgency=medium

  * Import new upstream version
  * d/compat:
    - Bump compat version to 12
  * d/control:
    - Bump Standards-Version to 4.3.0
    - Bump debhelper version to 12

 -- SZ Lin (林上智) <szlin@debian.org>  Wed, 02 Jan 2019 09:54:36 +0800

=== debian/control ===
--- 
+++ 
@@ -2,10 +2,10 @@
 Section: misc
 Priority: optional
 Maintainer: SZ Lin (林上智) <szlin@debian.org>
-Build-Depends: debhelper (>= 11),
+Build-Depends: debhelper (>= 12),
                libncurses-dev,
                pkg-config
-Standards-Version: 4.2.1
+Standards-Version: 4.3.0
 Homepage: https://github.com/jarun/nnn
 Vcs-Git: https://salsa.debian.org/debian/nnn.git
 Vcs-Browser: https://salsa.debian.org/debian/nnn
@@ -13,6 +13,13 @@
 Package: nnn
 Architecture: any
 Depends: ${shlibs:Depends}, ${misc:Depends}
+Suggests: mediainfo | exiftool,
+          atool | patool,
+          moreutils,
+          vlock,
+          file,
+          lftp,
+          xdg-utils
 Description: Free, fast, friendly file manager
  nnn is a fork of noice, a blazing-fast lightweight terminal file manager
  with easy keyboard shortcuts for navigation, opening files and running tasks.

## nnn 2.5

=== Makefile ===
--- 
+++ 
@@ -1,4 +1,4 @@
-VERSION = 2.2
+VERSION = 2.5
 
 PREFIX ?= /usr/local
 MANPREFIX ?= $(PREFIX)/share/man
@@ -33,10 +33,14 @@
 $(SRC): src/nnn.h
 
 $(BIN): $(SRC)
-	$(CC) $(CPPFLAGS) $(CFLAGS) $(LDFLAGS) -o $@ $^ $(LDLIBS)
+	$(CC) $(CPPFLAGS) $(CFLAGS) $(LDFLAGS) -o $@ $^ $(LDLIBS) -lreadline
 
 debug: $(SRC)
-	$(CC) -DDEBUGMODE -g $(CPPFLAGS) $(CFLAGS) $(LDFLAGS) -o $(BIN) $^ $(LDLIBS)
+	$(CC) -DDBGMODE -g $(CPPFLAGS) $(CFLAGS) $(LDFLAGS) -o $(BIN) $^ $(LDLIBS) -lreadline -lrt
+
+norl: $(SRC)
+	$(CC) -DNORL $(CPPFLAGS) $(CFLAGS) $(LDFLAGS) -o $(BIN) $^ $(LDLIBS)
+	$(STRIP) $(BIN)
 
 install: all
 	$(INSTALL) -m 0755 -d $(DESTDIR)$(PREFIX)/bin
@@ -63,4 +67,4 @@
 
 skip: ;
 
-.PHONY: $(BIN) $(SRC) all debug install uninstall strip dist clean
+.PHONY: all debug install uninstall strip dist clean

=== debian/changelog ===
nnn (2.5-1) unstable; urgency=medium

  * Import new upstream version
  * d/control:
    - Update package list in Suggest column
  * d/watch:
    - Fix malformed filenamemangle

 -- SZ Lin (林上智) <szlin@debian.org>  Mon, 27 May 2019 11:50:53 +0800

nnn (2.4-1) unstable; urgency=medium

  * Import new upstream version
  * d/control:
    - Add readline into {build-}Depends field
  * d/watch:
    - Remove dh_make-template

 -- SZ Lin (林上智) <szlin@debian.org>  Mon, 01 Apr 2019 18:09:30 +0800

=== debian/control ===
--- 
+++ 
@@ -4,6 +4,7 @@
 Maintainer: SZ Lin (林上智) <szlin@debian.org>
 Build-Depends: debhelper (>= 12),
                libncurses-dev,
+               libreadline-dev,
                pkg-config
 Standards-Version: 4.3.0
 Homepage: https://github.com/jarun/nnn
@@ -12,13 +13,15 @@
 
 Package: nnn
 Architecture: any
-Depends: ${shlibs:Depends}, ${misc:Depends}
+Depends: ${shlibs:Depends},
+         ${misc:Depends},
+         readline-common
 Suggests: mediainfo | exiftool,
           atool | patool,
-          moreutils,
           vlock,
           file,
           lftp,
+          sshfs,
           xdg-utils
 Description: Free, fast, friendly file manager
  nnn is a fork of noice, a blazing-fast lightweight terminal file manager

## nnn 2.6

=== Makefile ===
--- 
+++ 
@@ -1,10 +1,11 @@
-VERSION = 2.5
+VERSION = 2.6
 
 PREFIX ?= /usr/local
 MANPREFIX ?= $(PREFIX)/share/man
 STRIP ?= strip
 PKG_CONFIG ?= pkg-config
 INSTALL ?= install
+CP ?= cp
 
 CFLAGS_OPTIMIZATION ?= -O3
 
@@ -40,7 +41,6 @@
 
 norl: $(SRC)
 	$(CC) -DNORL $(CPPFLAGS) $(CFLAGS) $(LDFLAGS) -o $(BIN) $^ $(LDLIBS)
-	$(STRIP) $(BIN)
 
 install: all
 	$(INSTALL) -m 0755 -d $(DESTDIR)$(PREFIX)/bin

=== debian/changelog ===
nnn (2.6-1) unstable; urgency=medium

  * Import new upstream version
  * Bump Standards-Version to 4.4.0
  * d/install:
    - Correct the installation path to align with new upstream
    - Add zsh auto-completion script

 -- SZ Lin (林上智) <szlin@debian.org>  Tue, 06 Aug 2019 13:38:36 +0800

=== debian/control ===
--- 
+++ 
@@ -6,7 +6,7 @@
                libncurses-dev,
                libreadline-dev,
                pkg-config
-Standards-Version: 4.3.0
+Standards-Version: 4.4.0
 Homepage: https://github.com/jarun/nnn
 Vcs-Git: https://salsa.debian.org/debian/nnn.git
 Vcs-Browser: https://salsa.debian.org/debian/nnn

## nnn 2.8.1

=== debian/changelog ===
nnn (2.8.1-1.antix1) unstable; urgency=medium

  * buster build for antiX-19 

 -- anticapitalista <antix@operamail.com>  Sun, 05 Jan 2020 11:23:39 +0200

nnn (2.8.1-1) unstable; urgency=medium

  * Import new upstream version

 -- SZ Lin (林上智) <szlin@debian.org>  Thu, 05 Dec 2019 16:09:02 +0800

nnn (2.8-1) unstable; urgency=medium

  * Import new upstream version

 -- SZ Lin (林上智) <szlin@debian.org>  Wed, 04 Dec 2019 14:34:40 +0800

nnn (2.7-1) unstable; urgency=medium

  * Import new upstream version
  * d/control:
    - Use debhelper-compat (= 12) in build-dependency to replace d/compat
    - Set Rules-Requires-Root: no
    - Bump Standards-Version to 4.4.1

 -- SZ Lin (林上智) <szlin@debian.org>  Tue, 08 Oct 2019 15:31:38 +0800

=== debian/control ===
--- 
+++ 
@@ -2,11 +2,12 @@
 Section: misc
 Priority: optional
 Maintainer: SZ Lin (林上智) <szlin@debian.org>
-Build-Depends: debhelper (>= 12),
+Build-Depends: debhelper-compat (= 12),
                libncurses-dev,
                libreadline-dev,
                pkg-config
-Standards-Version: 4.4.0
+Standards-Version: 4.4.1
+Rules-Requires-Root: no
 Homepage: https://github.com/jarun/nnn
 Vcs-Git: https://salsa.debian.org/debian/nnn.git
 Vcs-Browser: https://salsa.debian.org/debian/nnn

## nnn 2.9

=== debian/changelog ===
nnn (2.9-1) unstable; urgency=medium

  * Import new upstream version
  * d/control:
    - Bump Standards-Version to 4.5.0

 -- SZ Lin (林上智) <szlin@debian.org>  Mon, 27 Jan 2020 16:35:54 +0800

## nnn 3.0

=== Makefile ===
VERSION = $(shell grep -m1 VERSION $(SRC) | cut -f 2 -d'"')

PREFIX ?= /usr/local
MANPREFIX ?= $(PREFIX)/share/man
STRIP ?= strip
PKG_CONFIG ?= pkg-config
INSTALL ?= install
CP ?= cp

CFLAGS_OPTIMIZATION ?= -O3

O_DEBUG := 0
O_NORL := 0  # no readline support
O_NOLOC := 0  # no locale support

# convert targets to flags for backwards compatibility
ifneq ($(filter debug,$(MAKECMDGOALS)),)
	O_DEBUG := 1
endif
ifneq ($(filter norl,$(MAKECMDGOALS)),)
	O_NORL := 1
endif
ifneq ($(filter noloc,$(MAKECMDGOALS)),)
	O_NORL := 1
	O_NOLOC := 1
endif

ifeq ($(O_DEBUG),1)
	CPPFLAGS += -DDBGMODE
	CFLAGS += -g
endif

ifeq ($(O_NORL),1)
	CPPFLAGS += -DNORL
else ifeq ($(O_STATIC),1)
	CPPFLAGS += -DNORL
else
	LDLIBS += -lreadline
endif

ifeq ($(O_PCRE),1)
	CPPFLAGS += -DPCRE
	LDLIBS += -lpcre
endif

ifeq ($(O_NOLOC),1)
	CPPFLAGS += -DNOLOCALE
endif

ifeq ($(shell $(PKG_CONFIG) ncursesw && echo 1),1)
	CFLAGS_CURSES ?= $(shell $(PKG_CONFIG) --cflags ncursesw)
	LDLIBS_CURSES ?= $(shell $(PKG_CONFIG) --libs   ncursesw)
else ifeq ($(shell $(PKG_CONFIG) ncurses && echo 1),1)
	CFLAGS_CURSES ?= $(shell $(PKG_CONFIG) --cflags ncurses)
	LDLIBS_CURSES ?= $(shell $(PKG_CONFIG) --libs   ncurses)
else
	LDLIBS_CURSES ?= -lncurses
endif

CFLAGS += -Wall -Wextra
CFLAGS += $(CFLAGS_OPTIMIZATION)
CFLAGS += $(CFLAGS_CURSES)

LDLIBS += $(LDLIBS_CURSES)

# static compilation needs libgpm development package
ifeq ($(O_STATIC),1)
	LDFLAGS += -static
	LDLIBS += -lgpm
endif

DISTFILES = src nnn.1 Makefile README.md LICENSE
SRC = src/nnn.c
HEADERS = src/nnn.h
BIN = nnn

all: $(BIN)

$(BIN): $(SRC) $(HEADERS)
	$(CC) $(CPPFLAGS) $(CFLAGS) $(LDFLAGS) -o $@ $< $(LDLIBS)

# targets for backwards compatibility
debug: $(BIN)
norl: $(BIN)
noloc: $(BIN)

install: all
	$(INSTALL) -m 0755 -d $(DESTDIR)$(PREFIX)/bin
	$(INSTALL) -m 0755 $(BIN) $(DESTDIR)$(PREFIX)/bin
	$(INSTALL) -m 0755 -d $(DESTDIR)$(MANPREFIX)/man1
	$(INSTALL) -m 0644 $(BIN).1 $(DESTDIR)$(MANPREFIX)/man1

uninstall:
	$(RM) $(DESTDIR)$(PREFIX)/bin/$(BIN)
	$(RM) $(DESTDIR)$(MANPREFIX)/man1/$(BIN).1

strip: $(BIN)
	$(STRIP) $^

static:
	make O_STATIC=1 strip
	mv $(BIN) $(BIN)-static

dist:
	mkdir -p nnn-$(VERSION)
	$(CP) -r $(DISTFILES) nnn-$(VERSION)
	tar -cf - nnn-$(VERSION) | gzip > nnn-$(VERSION).tar.gz
	$(RM) -r nnn-$(VERSION)

sign:
	git archive -o nnn-$(VERSION).tar.gz --format tar.gz --prefix=nnn-$(VERSION)/ v$(VERSION)
	gpg --detach-sign --yes nnn-$(VERSION).tar.gz
	rm -f nnn-$(VERSION).tar.gz

upload-local: sign static
	$(eval ID=$(shell curl -s 'https://api.github.com/repos/jarun/nnn/releases/tags/v$(VERSION)' | jq .id))
	curl -XPOST 'https://uploads.github.com/repos/jarun/nnn/releases/$(ID)/assets?name=nnn-$(VERSION).tar.gz.sig' \
	    -H 'Authorization: token $(NNN_SIG_UPLOAD_TOKEN)' -H 'Content-Type: application/pgp-signature' \
	    --upload-file nnn-$(VERSION).tar.gz.sig
	tar -cf $(BIN)-static-$(VERSION).x86-64.tar.gz $(BIN)-static
	curl -XPOST 'https://uploads.github.com/repos/jarun/nnn/releases/$(ID)/assets?name=nnn-$(VERSION)-static' \
	    -H 'Authorization: token $(NNN_SIG_UPLOAD_TOKEN)' -H 'Content-Type: application/x-sharedlib' \
	    --upload-file $(BIN)-static-$(VERSION).x86-64.tar.gz

clean:
	$(RM) -f $(BIN) nnn-$(VERSION).tar.gz *.sig \
	    $(BIN)-static $(BIN)-static-$(VERSION).x86-64.tar.gz

skip: ;

.PHONY: all install uninstall strip static dist sign upload-local clean

=== misc/haiku/Makefile ===
VERSION = $(shell grep -m1 VERSION $(SRC) | cut -f 2 -d'"')

PREFIX ?= /boot/system/non-packaged
MANPREFIX ?= $(PREFIX)/documentation/man
STRIP ?= strip
PKG_CONFIG ?= pkg-config
INSTALL ?= install
CP ?= cp

CFLAGS_OPTIMIZATION ?= -O3

O_DEBUG := 0
O_NORL := 0  # no readline support
O_NOLOC := 0  # no locale support

# convert targets to flags for backwards compatibility
ifneq ($(filter debug,$(MAKECMDGOALS)),)
	O_DEBUG := 1
endif
ifneq ($(filter norl,$(MAKECMDGOALS)),)
	O_NORL := 1
endif
ifneq ($(filter noloc,$(MAKECMDGOALS)),)
	O_NORL := 1
	O_NOLOC := 1
endif

ifeq ($(O_DEBUG),1)
	CPPFLAGS += -DDBGMODE
	CFLAGS += -g
	LDLIBS += -lrt
endif

ifeq ($(O_NORL),1)
	CPPFLAGS += -DNORL
else
	LDLIBS += -lreadline
endif

ifeq ($(O_NOLOC),1)
	CPPFLAGS += -DNOLOCALE
endif

ifeq ($(shell $(PKG_CONFIG) ncursesw && echo 1),1)
	CFLAGS_CURSES ?= $(shell $(PKG_CONFIG) --cflags ncursesw)
	LDLIBS_CURSES ?= $(shell $(PKG_CONFIG) --libs   ncursesw)
else ifeq ($(shell $(PKG_CONFIG) ncurses && echo 1),1)
	CFLAGS_CURSES ?= $(shell $(PKG_CONFIG) --cflags ncurses)
	LDLIBS_CURSES ?= $(shell $(PKG_CONFIG) --libs   ncurses)
else
	LDLIBS_CURSES ?= -lncurses
endif

ifeq ($(shell uname -s), Haiku)
	LDLIBS_HAIKU ?= -lstdc++ -lbe
	SRC_HAIKU ?= misc/haiku/nm.cpp
	OBJS_HAIKU ?= misc/haiku/nm.o
endif

CFLAGS += -Wall -Wextra
CFLAGS += $(CFLAGS_OPTIMIZATION)
CFLAGS += $(CFLAGS_CURSES)

LDLIBS += $(LDLIBS_CURSES) $(LDLIBS_HAIKU)

DISTFILES = src nnn.1 Makefile README.md LICENSE
SRC = src/nnn.c
HEADERS = src/nnn.h
BIN = nnn
OBJS := nnn.o $(OBJS_HAIKU)

all: $(BIN)

ifeq ($(shell uname -s), Haiku)
$(OBJS_HAIKU): $(SRC_HAIKU)
	$(CC) -c $(CPPFLAGS) $(CFLAGS) -o $@ $<
endif

nnn.o: $(SRC) $(HEADERS)
	$(CC) -c $(CPPFLAGS) $(CFLAGS) -o $@ $<

$(BIN): $(OBJS)
	$(CC) $(LDFLAGS) -o $@ $^ $(LDLIBS)

# targets for backwards compatibility
debug: $(BIN)
norl: $(BIN)
noloc: $(BIN)

install: all
	$(INSTALL) -m 0755 -d $(DESTDIR)$(PREFIX)/bin
	$(INSTALL) -m 0755 $(BIN) $(DESTDIR)$(PREFIX)/bin
	$(INSTALL) -m 0755 -d $(DESTDIR)$(MANPREFIX)/man1
	$(INSTALL) -m 0644 $(BIN).1 $(DESTDIR)$(MANPREFIX)/man1

uninstall:
	$(RM) $(DESTDIR)$(PREFIX)/bin/$(BIN)
	$(RM) $(DESTDIR)$(MANPREFIX)/man1/$(BIN).1

strip: $(BIN)
	$(STRIP) $^

static:
	make O_STATIC=1 strip
	mv $(BIN) $(BIN)-static

dist:
	mkdir -p nnn-$(VERSION)
	$(CP) -r $(DISTFILES) nnn-$(VERSION)
	mkdir -p nnn-$(VERSION)/misc
	$(CP) -r misc/haiku nnn-$(VERSION)/misc
	tar -cf - nnn-$(VERSION) | gzip > nnn-$(VERSION).tar.gz
	$(RM) -r nnn-$(VERSION)

sign:
	git archive -o nnn-$(VERSION).tar.gz --format tar.gz --prefix=nnn-$(VERSION)/ v$(VERSION)
	gpg --detach-sign --yes nnn-$(VERSION).tar.gz
	rm -f nnn-$(VERSION).tar.gz

upload-local: sign static
	$(eval ID=$(shell curl -s 'https://api.github.com/repos/jarun/nnn/releases/tags/v$(VERSION)' | jq .id))
	curl -XPOST 'https://uploads.github.com/repos/jarun/nnn/releases/$(ID)/assets?name=nnn-$(VERSION).tar.gz.sig' \
	    -H 'Authorization: token $(NNN_SIG_UPLOAD_TOKEN)' -H 'Content-Type: application/pgp-signature' \
	    --upload-file nnn-$(VERSION).tar.gz.sig
	curl -XPOST 'https://uploads.github.com/repos/jarun/nnn/releases/$(ID)/assets?name=nnn-$(VERSION)-static' \
	    -H 'Authorization: token $(NNN_SIG_UPLOAD_TOKEN)' -H 'Content-Type: application/x-sharedlib' \
	    --upload-file $(BIN)-static

clean:
	$(RM) -f $(BIN) $(BIN)-static $(OBJS) nnn-$(VERSION).tar.gz *.sig

skip: ;

.PHONY: all install uninstall strip static dist sign upload-local clean

=== debian/changelog ===
nnn (3.0-2) unstable; urgency=low

  * Add autopkgtest test case

 -- SZ Lin (林上智) <szlin@debian.org>  Tue, 18 Feb 2020 19:13:42 +0800

nnn (3.0-1) unstable; urgency=medium

  * Import new upstream version

 -- SZ Lin (林上智) <szlin@debian.org>  Thu, 13 Feb 2020 14:26:28 +0800

=== debian/control ===
--- 
+++ 
@@ -6,7 +6,7 @@
                libncurses-dev,
                libreadline-dev,
                pkg-config
-Standards-Version: 4.4.1
+Standards-Version: 4.5.0
 Rules-Requires-Root: no
 Homepage: https://github.com/jarun/nnn
 Vcs-Git: https://salsa.debian.org/debian/nnn.git

=== debian/watch ===
version=4
opts=filenamemangle=s/.+\/v?(\d\S+)\.tar\.gz/nnn-$1\.tar\.gz/ \
   https://github.com/jarun/nnn/releases \
   (?:.*?/)?v?(\d[\d.]*)\.tar\.gz debian uupdate

## nnn 3.4

=== debian/changelog ===
nnn (3.4-2) unstable; urgency=medium

  * d/tests/test:
    - Mark as superficial (Closes: #971482)

 -- SZ Lin (林上智) <szlin@debian.org>  Thu, 29 Oct 2020 10:26:03 +0800

nnn (3.4-1) unstable; urgency=medium

  * Import new upstream version

 -- SZ Lin (林上智) <szlin@debian.org>  Thu, 27 Aug 2020 15:10:42 +0800

nnn (3.3-1) unstable; urgency=medium

  * Import new upstream version

 -- SZ Lin (林上智) <szlin@debian.org>  Tue, 14 Jul 2020 10:52:31 +0800

nnn (3.2-1) unstable; urgency=medium

  * Import new upstream version
  * d/control:
    - Bump debhelper-compat to 13
  * d/copyright:
    - Correct copyright information

 -- SZ Lin (林上智) <szlin@debian.org>  Tue, 26 May 2020 11:14:53 +0800

nnn (3.1-1) unstable; urgency=medium

  * Import new upstream version

 -- SZ Lin (林上智) <szlin@debian.org>  Mon, 13 Apr 2020 17:58:36 +0800

## nnn 3.5

=== Makefile ===
--- 
+++ 
@@ -2,6 +2,8 @@
 
 PREFIX ?= /usr/local
 MANPREFIX ?= $(PREFIX)/share/man
+DESKTOPPREFIX ?= $(PREFIX)/share/applications
+DESKTOPICONPREFIX ?= $(PREFIX)/share/icons/hicolor
 STRIP ?= strip
 PKG_CONFIG ?= pkg-config
 INSTALL ?= install
@@ -9,9 +11,20 @@
 
 CFLAGS_OPTIMIZATION ?= -O3
 
-O_DEBUG := 0
+O_DEBUG := 0  # debug binary
 O_NORL := 0  # no readline support
+O_PCRE := 0  # link with PCRE library
 O_NOLOC := 0  # no locale support
+O_NOMOUSE := 0  # no mouse support
+O_NOBATCH := 0  # no built-in batch renamer
+O_NOFIFO := 0  # no FIFO previewer support
+O_CTX8 := 0  # enable 8 contexts
+O_ICONS := 0  # support icons-in-terminal
+O_NERD := 0  # support icons-nerdfont
+O_QSORT := 0  # use Alexey Tourbin's QSORT implementation
+O_BENCH := 0  # benchmark mode (stops at first user input)
+O_NOSSN := 0  # enable session support
+O_NOUG := 0  # disable user, group name in status bar
 
 # convert targets to flags for backwards compatibility
 ifneq ($(filter debug,$(MAKECMDGOALS)),)
@@ -45,6 +58,46 @@
 
 ifeq ($(O_NOLOC),1)
 	CPPFLAGS += -DNOLOCALE
+endif
+
+ifeq ($(O_NOMOUSE),1)
+	CPPFLAGS += -DNOMOUSE
+endif
+
+ifeq ($(O_NOBATCH),1)
+	CPPFLAGS += -DNOBATCH
+endif
+
+ifeq ($(O_NOFIFO),1)
+	CPPFLAGS += -DNOFIFO
+endif
+
+ifeq ($(O_CTX8),1)
+	CPPFLAGS += -DCTX8
+endif
+
+ifeq ($(O_ICONS),1)
+	CPPFLAGS += -DICONS
+endif
+
+ifeq ($(O_NERD),1)
+	CPPFLAGS += -DNERD
+endif
+
+ifeq ($(O_QSORT),1)
+	CPPFLAGS += -DTOURBIN_QSORT
+endif
+
+ifeq ($(O_BENCH),1)
+	CPPFLAGS += -DBENCH
+endif
+
+ifeq ($(O_NOSSN),1)
+	CPPFLAGS += -DNOSSN
+endif
+
+ifeq ($(O_NOUG),1)
+	CPPFLAGS += -DNOUG
 endif
 
 ifeq ($(shell $(PKG_CONFIG) ncursesw && echo 1),1)
@@ -57,7 +110,7 @@
 	LDLIBS_CURSES ?= -lncurses
 endif
 
-CFLAGS += -Wall -Wextra
+CFLAGS += -std=c11 -Wall -Wextra -Wshadow
 CFLAGS += $(CFLAGS_OPTIMIZATION)
 CFLAGS += $(CFLAGS_CURSES)
 
@@ -73,6 +126,9 @@
 SRC = src/nnn.c
 HEADERS = src/nnn.h
 BIN = nnn
+DESKTOPFILE = misc/desktop/nnn.desktop
+LOGOSVG = misc/logo/logo.svg
+LOGO64X64 = misc/logo/logo-64x64.png
 
 all: $(BIN)
 
@@ -83,6 +139,19 @@
 debug: $(BIN)
 norl: $(BIN)
 noloc: $(BIN)
+
+install-desktop: $(DESKTOPFILE)
+	$(INSTALL) -m 0755 -d $(DESTDIR)$(DESKTOPPREFIX)
+	$(INSTALL) -m 0644 $(DESKTOPFILE) $(DESTDIR)$(DESKTOPPREFIX)
+	$(INSTALL) -m 0755 -d $(DESTDIR)$(DESKTOPICONPREFIX)/scalable/apps
+	$(INSTALL) -m 0644 $(LOGOSVG) $(DESTDIR)$(DESKTOPICONPREFIX)/scalable/apps/nnn.svg
+	$(INSTALL) -m 0755 -d $(DESTDIR)$(DESKTOPICONPREFIX)/64x64/apps
+	$(INSTALL) -m 0644 $(LOGO64X64) $(DESTDIR)$(DESKTOPICONPREFIX)/64x64/apps/nnn.png
+
+uninstall-desktop:
+	$(RM) $(DESTDIR)$(DESKTOPPREFIX)/$(DESKTOPFILE)
+	$(RM) $(DESTDIR)$(DESKTOPICONPREFIX)/scalable/apps/nnn.svg
+	$(RM) $(DESTDIR)$(DESKTOPICONPREFIX)/64x64/apps/nnn.png
 
 install: all
 	$(INSTALL) -m 0755 -d $(DESTDIR)$(PREFIX)/bin
@@ -97,9 +166,20 @@
 strip: $(BIN)
 	$(STRIP) $^
 
+upx: $(BIN)
+	$(STRIP) $^
+	upx -qqq $^
+
 static:
+	# regular static binary
 	make O_STATIC=1 strip
 	mv $(BIN) $(BIN)-static
+	# static binary with icons-in-terminal support
+	make O_STATIC=1 O_ICONS=1 strip
+	mv $(BIN) $(BIN)-icons-static
+	# static binary with patched nerd font support
+	make O_STATIC=1 O_NERD=1 strip
+	mv $(BIN) $(BIN)-nerd-static
 
 dist:
 	mkdir -p nnn-$(VERSION)
@@ -114,18 +194,33 @@
 
 upload-local: sign static
 	$(eval ID=$(shell curl -s 'https://api.github.com/repos/jarun/nnn/releases/tags/v$(VERSION)' | jq .id))
+	# upload sign file
 	curl -XPOST 'https://uploads.github.com/repos/jarun/nnn/releases/$(ID)/assets?name=nnn-$(VERSION).tar.gz.sig' \
 	    -H 'Authorization: token $(NNN_SIG_UPLOAD_TOKEN)' -H 'Content-Type: application/pgp-signature' \
 	    --upload-file nnn-$(VERSION).tar.gz.sig
-	tar -cf $(BIN)-static-$(VERSION).x86-64.tar.gz $(BIN)-static
-	curl -XPOST 'https://uploads.github.com/repos/jarun/nnn/releases/$(ID)/assets?name=nnn-$(VERSION)-static' \
+	tar -zcf $(BIN)-static-$(VERSION).x86_64.tar.gz $(BIN)-static
+	# upx compress all static binaries
+	upx -qqq $(BIN)-static
+	upx -qqq $(BIN)-icons-static
+	upx -qqq $(BIN)-nerd-static
+	# upload static binary
+	curl -XPOST 'https://uploads.github.com/repos/jarun/nnn/releases/$(ID)/assets?name=$(BIN)-static-$(VERSION).x86_64.tar.gz' \
 	    -H 'Authorization: token $(NNN_SIG_UPLOAD_TOKEN)' -H 'Content-Type: application/x-sharedlib' \
-	    --upload-file $(BIN)-static-$(VERSION).x86-64.tar.gz
+	    --upload-file $(BIN)-static-$(VERSION).x86_64.tar.gz
+	tar -zcf $(BIN)-icons-static-$(VERSION).x86_64.tar.gz $(BIN)-icons-static
+	# upload icons-in-terminal compiled static binary
+	curl -XPOST 'https://uploads.github.com/repos/jarun/nnn/releases/$(ID)/assets?name=$(BIN)-icons-static-$(VERSION).x86_64.tar.gz' \
+	    -H 'Authorization: token $(NNN_SIG_UPLOAD_TOKEN)' -H 'Content-Type: application/x-sharedlib' \
+	    --upload-file $(BIN)-icons-static-$(VERSION).x86_64.tar.gz
+	# upload patched nerd font compiled static binary
+	tar -zcf $(BIN)-nerd-static-$(VERSION).x86_64.tar.gz $(BIN)-nerd-static
+	curl -XPOST 'https://uploads.github.com/repos/jarun/nnn/releases/$(ID)/assets?name=$(BIN)-nerd-static-$(VERSION).x86_64.tar.gz' \
+	    -H 'Authorization: token $(NNN_SIG_UPLOAD_TOKEN)' -H 'Content-Type: application/x-sharedlib' \
+	    --upload-file $(BIN)-nerd-static-$(VERSION).x86_64.tar.gz
 
 clean:
-	$(RM) -f $(BIN) nnn-$(VERSION).tar.gz *.sig \
-	    $(BIN)-static $(BIN)-static-$(VERSION).x86-64.tar.gz
+	$(RM) -f $(BIN) nnn-$(VERSION).tar.gz *.sig $(BIN)-static $(BIN)-static-$(VERSION).x86_64.tar.gz $(BIN)-icons-static $(BIN)-icons-static-$(VERSION).x86_64.tar.gz $(BIN)-nerd-static $(BIN)-nerd-static-$(VERSION).x86_64.tar.gz
 
 skip: ;
 
-.PHONY: all install uninstall strip static dist sign upload-local clean
+.PHONY: all install uninstall strip static dist sign upload-local clean install-desktop uninstall-desktop

=== misc/haiku/Makefile ===
--- 
+++ 
@@ -9,9 +9,20 @@
 
 CFLAGS_OPTIMIZATION ?= -O3
 
-O_DEBUG := 0
+O_DEBUG := 0  # debug binary
 O_NORL := 0  # no readline support
+O_PCRE := 0  # link with PCRE library
 O_NOLOC := 0  # no locale support
+O_NOMOUSE := 0  # no mouse support
+O_NOBATCH := 0  # no built-in batch renamer
+O_NOFIFO := 0  # no FIFO previewer support
+O_CTX8 := 0  # enable 8 contexts
+O_ICONS := 0  # support icons-in-terminal
+O_NERD := 0  # support icons-nerdfont
+O_QSORT := 0  # use Alexey Tourbin's QSORT implementation
+O_BENCH := 0  # benchmark mode (stops at first user input)
+O_NOSSN := 0  # enable session support
+O_NOUG := 0  # disable user, group name in status bar
 
 # convert targets to flags for backwards compatibility
 ifneq ($(filter debug,$(MAKECMDGOALS)),)
@@ -33,12 +44,59 @@
 
 ifeq ($(O_NORL),1)
 	CPPFLAGS += -DNORL
+else ifeq ($(O_STATIC),1)
+	CPPFLAGS += -DNORL
 else
 	LDLIBS += -lreadline
 endif
 
+ifeq ($(O_PCRE),1)
+	CPPFLAGS += -DPCRE
+	LDLIBS += -lpcre
+endif
+
 ifeq ($(O_NOLOC),1)
 	CPPFLAGS += -DNOLOCALE
+endif
+
+ifeq ($(O_NOMOUSE),1)
+	CPPFLAGS += -DNOMOUSE
+endif
+
+ifeq ($(O_NOBATCH),1)
+	CPPFLAGS += -DNOBATCH
+endif
+
+ifeq ($(O_NOFIFO),1)
+	CPPFLAGS += -DNOFIFO
+endif
+
+ifeq ($(O_CTX8),1)
+	CPPFLAGS += -DCTX8
+endif
+
+ifeq ($(O_ICONS),1)
+	CPPFLAGS += -DICONS
+endif
+
+ifeq ($(O_NERD),1)
+	CPPFLAGS += -DNERD
+endif
+
+ifeq ($(O_QSORT),1)
+	CPPFLAGS += -DTOURBIN_QSORT
+endif
+
+ifeq ($(O_BENCH),1)
+	CPPFLAGS += -DBENCH
+endif
+
+ifeq ($(O_NOSSN),1)
+	CPPFLAGS += -DNOSSN
+endif
+
+ifeq ($(O_NOUG),1)
+	CPPFLAGS += -DNOUG
 endif
 
 ifeq ($(shell $(PKG_CONFIG) ncursesw && echo 1),1)
@@ -57,11 +115,17 @@
 	OBJS_HAIKU ?= misc/haiku/nm.o
 endif
 
-CFLAGS += -Wall -Wextra
+CFLAGS += -std=c11 -Wall -Wextra -Wshadow
 CFLAGS += $(CFLAGS_OPTIMIZATION)
 CFLAGS += $(CFLAGS_CURSES)
 
 LDLIBS += $(LDLIBS_CURSES) $(LDLIBS_HAIKU)
+
+# static compilation needs libgpm development package
+ifeq ($(O_STATIC),1)
+	LDFLAGS += -static
+	LDLIBS += -lgpm
+endif
 
 DISTFILES = src nnn.1 Makefile README.md LICENSE
 SRC = src/nnn.c
@@ -119,15 +183,18 @@
 
 upload-local: sign static
 	$(eval ID=$(shell curl -s 'https://api.github.com/repos/jarun/nnn/releases/tags/v$(VERSION)' | jq .id))
+	# upload sign file
 	curl -XPOST 'https://uploads.github.com/repos/jarun/nnn/releases/$(ID)/assets?name=nnn-$(VERSION).tar.gz.sig' \
 	    -H 'Authorization: token $(NNN_SIG_UPLOAD_TOKEN)' -H 'Content-Type: application/pgp-signature' \
 	    --upload-file nnn-$(VERSION).tar.gz.sig
-	curl -XPOST 'https://uploads.github.com/repos/jarun/nnn/releases/$(ID)/assets?name=nnn-$(VERSION)-static' \
+	tar -zcf $(BIN)-static-$(VERSION).x86_64.tar.gz $(BIN)-static
+	# upload static binary
+	curl -XPOST 'https://uploads.github.com/repos/jarun/nnn/releases/$(ID)/assets?name=$(BIN)-static-$(VERSION).x86_64.tar.gz' \
 	    -H 'Authorization: token $(NNN_SIG_UPLOAD_TOKEN)' -H 'Content-Type: application/x-sharedlib' \
-	    --upload-file $(BIN)-static
+	    --upload-file $(BIN)-static-$(VERSION).x86_64.tar.gz
 
 clean:
-	$(RM) -f $(BIN) $(BIN)-static $(OBJS) nnn-$(VERSION).tar.gz *.sig
+	$(RM) -f $(BIN) nnn-$(VERSION).tar.gz *.sig $(BIN)-static $(BIN)-static-$(VERSION).x86_64.tar.gz
 
 skip: ;

=== debian/changelog ===
nnn (3.5-1) unstable; urgency=medium

  * Import new upstream version
  * d/copyright:
    - Fix incorrect license declaration

 -- SZ Lin (林上智) <szlin@debian.org>  Wed, 18 Nov 2020 11:41:47 +0800

=== debian/control ===
--- 
+++ 
@@ -2,7 +2,7 @@
 Section: misc
 Priority: optional
 Maintainer: SZ Lin (林上智) <szlin@debian.org>
-Build-Depends: debhelper-compat (= 12),
+Build-Depends: debhelper-compat (= 13),
                libncurses-dev,
                libreadline-dev,
                pkg-config

=== debian/rules ===
#!/usr/bin/make -f

export DEB_BUILD_MAINT_OPTIONS = hardening=+all

%:
	dh $@

override_dh_auto_install:

override_dh_missing:
	dh_missing --fail-missing
